/*
		public domain uuencode.c
*/

/* #define TURBOC */

#include <stdio.h>
#ifndef VOS3
#  if defined(MSDOS) && !defined(NO_DOSFN)
#    include <dos.h>
#  else
#    include <sys/types.h>
#    include <sys/stat.h>
#  endif
#endif

#ifdef TOOLS
     /* UNIX-like tools1ƂăRpCEzzꍇ͂define
	AʃpbP[W(ektou)ŃRpCEzzꍇdefineȂB
	uMSDOS̏ꍇ͏tools.hincludevƂĂ͂Ȃ */
#  include "tools.h"
#else
#  define s_conv_to_unix_format(s) (s)
#  ifndef MSDOS
#    define fsetbin(f) 0
#  endif
typedef	unsigned char	bool;
#endif

#define	errout(s) fputs((s), stderr)
#define	errcout(c) fputc((c), stderr)

#ifdef VOS3
#  define ERRLVL 8
#else
#  define ERRLVL 1
#endif

char	*cmdname = "uuencode";

static	bool	textmode = 0, bs_dollar = 0, ident = 0, v3nocontln = 0;
static	bool	mimcnv_mode = 0, add_dscript = 0;

#ifdef VOS3
 /* VOS3ɂāASf[^Zbg'#'ŎwłBstring.hKv */
static	FILE	*expopen(fn, s, m)
FILE	*((*fn)());
char	*s, *m;
{
	char	*buf, *p, *malloc();
	FILE	*f;

	if(*s != '#') return((*fn)(s, m));
	if(NULL == (buf = malloc(strlen(s) + 2))){
		fprintf(stderr, "Sorry, can't malloc.\n");
		exit(ERRLVL);
	}
	p = buf;

	++s; /* skip '#' */
	*p++ = '\'';
	while(*s && *s != '/') *p++ = *s++;
	*p++ = '\'';
	while(*p++ = *s++);

	f = (*fn)(buf, m);
	free(buf);
	return(f);
}
static	FILE	*orgfopen(s, m) char *s, *m; {return(fopen(s, m));}
static	FILE	*orgpopen(s, m) char *s, *m;
	{extern FILE *popen(); return(popen(s, m));}
#define fopen(s, m) expopen(orgfopen, s, m)
#define popen(s, m) expopen(orgpopen, s, m)

static	FILE	*binreopen(orgf, mode)
FILE	*orgf;
char	mode;
{
	static	char	opt[ ] = "?,BINARY";

	if(isterm(orgf)) return(orgf);
	*opt = mode;
	if((orgf= freopen(NULL, opt, orgf)) == NULL){
		fprintf(stderr, "Can't switch to binary mode.\n");
		exit(ERRLVL);
	}
	return(orgf);
}
#endif /* VOS3 */

static	void	encode();

static	void	usage()
{
	errout("Usage: "), errout(cmdname);
	errout(" [-tsivmu] [[infile] remotefile]\n");
	exit(ERRLVL);
}

static	FILE	*fopenchk(fnm, mode)
char	*fnm, *mode;
{
	register FILE	*f;

	if(NULL == (f = fopen(fnm, mode))){
		errout(cmdname), errout(": Can't open ");
		errout(s_conv_to_unix_format(fnm)), errcout('\n');
		exit(ERRLVL);
	}
	return(f);
}

#if defined(VOS3) || defined(TURBOC)
#  define getfmode(s, f) 0644
#else
#if defined(MSDOS) && !defined(NO_DOSFN)
#  define getfmode(s, f) getfmode2(s)
static	getfmode2(s)
char	*s;
{
	unsigned int	mode;

	if(0 != _dos_getfileattr(s, &mode)) return 0644;
	return (mode & 1) ? 0444 : 0644;
}
#else /* DOSłĂ_dos_getfileattr̂ȂRpCł͂g */
#  define getfmode(s, f) getfmode1(f)
static	getfmode1(f)
FILE	*f;
{
	struct	stat	statbuf;

	fstat(fileno(f), &statbuf);
#  ifdef MSDOS
	return(statbuf . st_mode & ~022);
#  else
	return(statbuf . st_mode);
#  endif
}
#endif
#endif

#ifdef VOS3
#  define getdeffmode() 0644
#else
static	getdeffmode()
{
	register int	fmode;

	umask(fmode = umask(0644));
#  ifdef MSDOS
	return((fmode ^ 0777) & 0644);
#  else
	return((fmode ^ 0777) & 0666);
#  endif
}
#endif

static	fputo(i, f) /* VOS3łOK */
int	i;
FILE	*f;
{
	if(i >> 3) fputo(i >> 3, f);
	return fputc((i & 7) + '0', f);
}

main(ac, av)
int	ac;
char	**av;
{
	int	c;
	extern	int	optind, opterr;
	register FILE	*inf, *otf;
	char	*remotename;
	int	fmode;

#ifdef TOOLS
#  ifdef EXPLICIT_EXPARG /* for tools */
	ac = expand_arg(av[0], get_psp_arg(), &av);
#  endif
#  ifndef MSDOS
	setcmdname(av[0]);
#  endif
	opterr = 0;
#endif

	while(EOF != (c	= getopt(ac, av, "tsivmu"))){
		switch(c){
		case 't': textmode = 1; break;
		case 's': bs_dollar ^= 1; break;
		case 'i': ident = 1; break;
		case 'v': v3nocontln = 1; break;
		case 'm': mimcnv_mode = 1; break;
		case 'u': add_dscript = 1; break;
		default: usage();
		}
	}

	av += optind;
	ac -= optind;

	otf = stdout;
	switch(ac){
	case 0:
		if(ident) usage();
		remotename = "dummy";
		inf = stdin;
		fmode = getdeffmode();
		break;
	case 1:
		remotename = av[0];
		if(ident){
			inf = fopenchk(av[0], "r");
			fmode = getfmode(av[0], inf) & 0777;
		} else {
			inf = stdin;
			fmode = getdeffmode();
		}
		break;
	case 2:
		if(ident) usage();
		remotename = av[1];
		inf = fopenchk(av[0], "r");
		fmode = getfmode(av[0], inf) & 0777;
		break;
	default:
		usage();
	}

	if(!textmode) fsetbin(inf);
#ifdef VOS3
	if(!textmode) binreopen(inf, 'r');
#endif

	if(add_dscript){
		fputs("\
: ; umask 077; T=/tmp/.uud$$_$USER; trap \"rm -f $T\" 0 1 2 3 15\n\
sed \"1s|\\([0-7] \\).*|\\1$T|\" << '~EOF' | uudecode && cat $T; exit\n\
"		 , otf);
	}
	fputs("begin ", otf), fputo(fmode, otf), fputc(' ', otf);
	fputs(
#if defined(TOOLS) && defined(MSDOS) && defined(SUPP_LFN)
		_lfnsupp_level > LFN_NONE ? remotename :
#endif
			s_conv_to_unix_format(remotename),
		otf);
	fputc('\n', otf);
	encode(inf, otf);
	return(0);
}

static	bfread(s, n, f)
char	*s;
int	n;
FILE	*f;
{
	register int	i, c;

	for(i = 0; i < n && EOF != (c = getc(f)); i++) *s++ = (char)c;
	return(i);
}

#ifndef VOS3
#  define totext(c) ((c) ? (c) + 0x20 : 0x60)
#else
extern	char	atoektbl[][0x100];
#  define totext(c) atoektbl[0][((c) ? (c) + 0x20 : 0x60)]
#endif
#define usgnch(c) (0xff & (int)(c))
#define ENCSIZ	45

static	mimch_cnv(c)
int	c;
{
#ifdef VOS3
	c = atoektbl[1][c & 0xff];
#endif
	 /* c must be 0x21`0x60 */
	if(c == 0x60) c = 0x2b; else
	if(c == 0x21) c = 0x2d; else
	if(c <= 0x2b) c -= 0x22 - 0x30; else
	if(c <= 0x45) c -= 0x2c - 0x41; else
		      c -= 0x46 - 0x61;
#ifdef VOS3
	c = atoektbl[0][c & 0xff];
#endif
	return c;
}

static	void	putc1(c, f)
int	c;
FILE	*f;
{
	if(bs_dollar){
		switch((char)c){
		case (char)'$': c = '\\'; break;
		case (char)'\\': c = '$'; break;
		}
	}
	if(mimcnv_mode) c = mimch_cnv(c);
	putc(c, f);
}

static	void	encode(inf, otf)
FILE	*inf, *otf;
{
	static	char	buf[ENCSIZ];
	char	cbuf;
	int	n;
	register int	i, j;
	register char	*p;

	while((n = bfread(buf, ENCSIZ, inf)) != 0){
		putc1(totext(n), otf);
		for(p = buf, i = 0; i < n; i += 3){
			for(cbuf = 0, j = 0; j < 3; j++){
				cbuf |= usgnch(*p) >> (j*2+2);
				putc1(totext(cbuf), otf);
				cbuf = (*p++ << (4-j*2)) & 0x3f;
			}
			putc1(totext(cbuf), otf);
		}
		if(v3nocontln){
			cbuf = totext(cbuf);
			if(mimcnv_mode) cbuf = (char)mimch_cnv(cbuf);
			if(cbuf == '+' || cbuf == '-') putc('X', otf);
		}
		putc('\n', otf);
	}
	putc1('`', otf);
	if(v3nocontln && mimcnv_mode) putc('X', otf);
	fputs("\nend\n", otf);
	if(add_dscript) fputs("~EOF\n", otf);
}
